/*----- PROTECTED REGION ID(Serial2.h) ENABLED START -----*/
//=============================================================================
//
// file :        Serial2.h
//
// description : Include file for the Serial2 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.8 $
// $Date: 2018-05-09 16:05:56 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Serial2_H
#define Serial2_H

#include <tango.h>

#define BUFFER_SIZE 1000

/*----- PROTECTED REGION END -----*/	//	Serial2.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  Serial2 class description:
 *    
 */


namespace Serial2_ns
{
/*----- PROTECTED REGION ID(Serial2::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Serial2::Additional Class Declarations

class Serial2 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Serial2::Data Members) ENABLED START -----*/

//	Add your own data members
	string init_error;

	int fd;
	fd_set readfds;
	fd_set writefds;
	fd_set errorfds;
	
	enum event_type { READ, WRITE };

	unsigned char buffer[ BUFFER_SIZE ];
	vector< unsigned char > data;

	bool connecting;
	long long reconnections;

	enum { SLEEP, SELECT } multiplexing;

/*----- PROTECTED REGION END -----*/	//	Serial2::Data Members

//	Device property data members
public:
	//	Serialline:	
	std::string	serialline;
	//	Charlength:	
	Tango::DevUShort	charlength;
	//	Parity:	
	std::string	parity;
	//	Baudrate:	
	Tango::DevULong	baudrate;
	//	Stopbits:	
	Tango::DevUShort	stopbits;
	//	Flowcontrol:	
	std::string	flowcontrol;
	//	Timeout:	
	Tango::DevLong	timeout;
	//	IOMultiplexing:	Use `sleep` for fixed sleep and `select` for ths syscall of the same name
	std::string	iOMultiplexing;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevLong	*attr_InputLength_read;
	Tango::DevLong	*attr_OutputLength_read;
	Tango::DevLong	*attr_Reconnections_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Serial2(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Serial2(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Serial2(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Serial2();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : Serial2::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute InputLength related methods
 *
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_InputLength(Tango::Attribute &attr);
	virtual bool is_InputLength_allowed(Tango::AttReqType type);
/**
 *	Attribute OutputLength related methods
 *
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_OutputLength(Tango::Attribute &attr);
	virtual bool is_OutputLength_allowed(Tango::AttReqType type);
/**
 *	Attribute Reconnections related methods
 *
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_Reconnections(Tango::Attribute &attr);
	virtual bool is_Reconnections_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : Serial2::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command Write related method
	 *
	 *
	 *	@param argin
	 */
	virtual void write(const Tango::DevVarCharArray *argin);
	virtual bool is_Write_allowed(const CORBA::Any &any);
	/**
	 *	Command Read related method
	 *
	 *
	 *	@param argin
	 *	@returns
	 */
	virtual Tango::DevVarCharArray *read(Tango::DevLong argin);
	virtual bool is_Read_allowed(const CORBA::Any &any);
	/**
	 *	Command ReadUntil related method
	 *
	 *
	 *	@param argin
	 *	@returns
	 */
	virtual Tango::DevVarCharArray *read_until(const Tango::DevVarCharArray *argin);
	virtual bool is_ReadUntil_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : Serial2::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Serial2::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
	void check_init();

	void open();
	void close();
	void check_connection( );
	bool wait_for( event_type et, timeval *tv );
	bool wait_for_with_sleep( event_type et, timeval *tv );
	bool wait_for_with_select( event_type et, timeval *tv );

	int input_queue_length();
	int output_queue_length();

	bool read( struct timeval *tv );

/*----- PROTECTED REGION END -----*/	//	Serial2::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Serial2::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Serial2::Additional Classes Definitions

}	//	End of namespace

#endif   //	Serial2_H
